require "import"
import "android.content.Intent"
import "android.net.Uri"
import "android.app.Activity"

-- Get the current activity context
local activity = activity or this

-- Define the YouTube channel link
local url = "https://www.youtube.com/@Technologyblindnepal"

-- Function to open the YouTube link
function openYouTubeLink()
    -- Notify the user with sound and speech that the process is starting
    service.playSoundTick() -- Play a tick sound
    service.asyncSpeak("Opening the YouTube channel, Technology Blind Nepal. Please wait.")
    
    -- Create an intent for the YouTube application
    local intent = Intent(Intent.ACTION_VIEW)
    intent.setData(Uri.parse(url))
    intent.setPackage("com.google.android.youtube") -- Specify YouTube app package

    -- Check if the YouTube app is installed
    if intent.resolveActivity(activity.getPackageManager()) ~= nil then
        -- Open the link in the YouTube app
        activity.startActivity(intent)
        service.playSoundTick() -- Play a tick sound again
        service.asyncSpeak("The link was successfully opened in the YouTube application.")
    else
        -- If YouTube app is not installed, open the link in a browser
        service.playSoundTick() -- Play a tick sound
        service.asyncSpeak("YouTube application is not installed. Opening the link in a browser.")
        local browserIntent = Intent(Intent.ACTION_VIEW)
        browserIntent.setData(Uri.parse(url))
        activity.startActivity(browserIntent)
    end
end

-- Call the function to open the YouTube link
openYouTubeLink()